#if !defined(AFX_COLORSELECTOR_H__9D9A9AD9_C388_11D3_BC2A_00E029364BE2__INCLUDED_)
#define AFX_COLORSELECTOR_H__9D9A9AD9_C388_11D3_BC2A_00E029364BE2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ColorSelector.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CColorSelector window

#define CSN_SELCHANGED		1
#define CSN_COLOREDITED		2

#define CSNC_FOREGROUND		1
#define CSNC_BACKGROUND		2

typedef struct
{
	NMHDR		hdr;
	int			nColorChanged;
	int			nIndex;
	WORD		wRGB;
} NMCOLORSELECTOR, FAR *LPNMCOLORSELECTOR;

class CColorSelector : public CWnd
{
// Construction
public:
	CColorSelector();

// Attributes
public:

protected:
	int m_nFGSel;
	int m_nBGSel;

	int m_nItemHeight;
	int m_nItemWidth;

	int m_nRows;

	CWordArray m_colors;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CColorSelector)
	protected:
	virtual void PreSubclassWindow();
	//}}AFX_VIRTUAL

// Implementation
public:
	int ItemFromPoint(CPoint pt);
	void ResetContent();
	void GetItemRect(int nIndex, LPRECT lpRect);
	int GetForegroundColor();
	int GetBackgroundColor();
	void SetForegroundColor(int nColor);
	void SetBackgroundColor(int nColor);
	void AddColors(WORD* aColors, int nColors);
	virtual ~CColorSelector();

	// Generated message map functions
protected:
	//{{AFX_MSG(CColorSelector)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnPaint();
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDblClk(UINT nFlags, CPoint point);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_COLORSELECTOR_H__9D9A9AD9_C388_11D3_BC2A_00E029364BE2__INCLUDED_)
