// DialoguePageList.cpp : implementation file
//

#include "stdafx.h"
#include "FF3Edit.h"
#include "DialoguePageList.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDialoguePageList

CDialoguePageList::CDialoguePageList()
{
	m_bmpWindow.LoadBitmap(IDB_TEXTWINDOW);
}

CDialoguePageList::~CDialoguePageList()
{
}


BEGIN_MESSAGE_MAP(CDialoguePageList, CListBox)
	//{{AFX_MSG_MAP(CDialoguePageList)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDialoguePageList message handlers

void CDialoguePageList::MeasureItem(LPMEASUREITEMSTRUCT lpmis) 
{
	lpmis->itemHeight = 96;
}

BYTE g_rawDTE[256] = {
	0x3E, 0x7F, 0x7F, 0x4D, 0x61, 0x7F, 0x4D, 0x41, 0x4D, 0x7F, 0x41, 0x3E, 0x4C, 0x7F, 0x3E, 0x4B,
	0x7F, 0x3A, 0x4B, 0x3E, 0x42, 0x47, 0x48, 0x4E, 0x3D, 0x7F, 0x7F, 0x50, 0x7F, 0x4C, 0x3A, 0x47,
	0x48, 0x7F, 0x7F, 0x41, 0x7F, 0x48, 0x4B, 0x7F, 0x47, 0x7F, 0x3A, 0x4D, 0x4D, 0x48, 0x7F, 0x42,
	0x66, 0x7F, 0x4F, 0x3E, 0x47, 0x40, 0x41, 0x3A, 0x7F, 0x46, 0x33, 0x41, 0x4C, 0x4D, 0x48, 0x47,
	0x52, 0x48, 0x7F, 0x3B, 0x46, 0x3E, 0x52, 0x7F, 0x3E, 0x47, 0x42, 0x4D, 0x3A, 0x4B, 0x45, 0x45,
	0x3E, 0x3A, 0x28, 0x7F, 0x3E, 0x3D, 0x7F, 0x3F, 0x7F, 0x52, 0x41, 0x42, 0x42, 0x4C, 0x3E, 0x4C,
	0x48, 0x4B, 0x45, 0x7F, 0x7F, 0x3C, 0x47, 0x3E, 0x63, 0x4C, 0x47, 0x3D, 0x45, 0x3E, 0x4C, 0x3E,
	0x7F, 0x28, 0x3A, 0x7F, 0x4D, 0x3E, 0x7F, 0x45, 0x49, 0x3E, 0x3A, 0x4C, 0x4E, 0x4B, 0x4E, 0x7F,
	0x3A, 0x45, 0x7F, 0x49, 0x40, 0x7F, 0x48, 0x46, 0x7F, 0x3D, 0x3F, 0x7F, 0x7F, 0x40, 0x48, 0x50,
	0x4B, 0x4C, 0x3B, 0x3E, 0x4B, 0x48, 0x4E, 0x4C, 0x4B, 0x42, 0x50, 0x3A, 0x50, 0x3E, 0x36, 0x41,
	0x3E, 0x4D, 0x7F, 0x4B, 0x47, 0x4D, 0x46, 0x7F, 0x46, 0x3A, 0x28, 0x63, 0x45, 0x42, 0x41, 0x48,
	0x48, 0x3F, 0x38, 0x48, 0x41, 0x7F, 0x7F, 0x47, 0x3E, 0x3E, 0x3D, 0x3E, 0x4C, 0x48, 0x40, 0x41,
	0x3C, 0x3A, 0x4B, 0x3A, 0x47, 0x63, 0x4D, 0x3A, 0x4E, 0x4D, 0x3E, 0x45, 0x5E, 0x7F, 0x3F, 0x48,
	0x4D, 0x42, 0x36, 0x3E, 0x45, 0x48, 0x3E, 0x5E, 0x45, 0x3D, 0x47, 0x48, 0x3A, 0x3C, 0x3C, 0x3E,
	0x44, 0x7F, 0x7F, 0x4E, 0x48, 0x48, 0x44, 0x3E, 0x3A, 0x52, 0x50, 0x7F, 0x5E, 0x5E, 0x3A, 0x40,
	0x42, 0x45, 0x45, 0x52, 0x3C, 0x48, 0x65, 0x7F, 0x3C, 0x41, 0x40, 0x48, 0x40, 0x3E, 0x3E, 0x67,
};

LPCTSTR g_rawNames[] = {
	"\x33\x24\x31\x31\x20\x00",			// TERRA
	"\x2B\x2E\x22\x2A\x24\x00",			// LOCKE
	"\x22\x38\x20\x2D\x00\x00",			// CYAN
	"\x32\x27\x20\x23\x2E\x36",			// SHADOW
	"\x24\x23\x26\x20\x31\x00",			// EDGAR
	"\x32\x20\x21\x28\x2D\x00",			// SABIN
	"\x22\x24\x2B\x24\x32\x00",			// CELES
	"\x32\x33\x31\x20\x26\x2E",			// STRAGO
	"\x31\x24\x2B\x2C\x00\x00",			// RELM
	"\x32\x24\x33\x39\x24\x31",			// SETZER
	"\x2C\x2E\x26\x00\x00\x00",			// MOG
	"\x26\x20\x34\x00\x00\x00",			// GAU
	"\x26\x2E\x26\x2E\x00\x00",			// GOGO
	"\x34\x2C\x20\x31\x2E\x00"			// UMARO
};

LPCTSTR g_rawCtrl[] = {
	"\x2D\x34\x2C\x21\x24\x31",			// NUMBER
	"\x28\x33\x24\x2C\x00\x00",			// ITEM
	"\x32\x2F\x24\x2B\x2B\x00",			// SPELL
};

#define WINDOWWIDTH 236

void CDialoguePageList::DrawItem(LPDRAWITEMSTRUCT lpdis) 
{
	CDC dc;  dc.Attach(lpdis->hDC);

	CRect rect = lpdis->rcItem;
	UINT nIndex = lpdis->itemID;

	CRect winRect(rect.left + 4, rect.top + 4, rect.left + 244, rect.top + 76);
	CRect pageRect(rect.left + 4, rect.bottom - 18, rect.right - 4, rect.bottom - 4);

	if(nIndex != (UINT)-1)
	{
		CDC dcMem;
		dcMem.CreateCompatibleDC(NULL);
		CBitmap* pOldBmp = dcMem.SelectObject(&m_bmpWindow);
		dc.BitBlt(winRect.left, winRect.top, 240, 72, &dcMem, 0, 0, SRCCOPY);
		dcMem.SelectObject(pOldBmp);

		CString p;  p.Format("Page %d", nIndex + 1);

		int nHeight = -((dc.GetDeviceCaps(LOGPIXELSY) * 8.5) / 72);
		CFont font;  font.CreateFont(nHeight, 0, 0, 0, FW_NORMAL, 0, 0, 0, DEFAULT_CHARSET, OUT_CHARACTER_PRECIS, CLIP_CHARACTER_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, "Tahoma");
		CFont* pOldFont = dc.SelectObject(&font);

		dc.DrawText(p, pageRect, DT_VCENTER | DT_RIGHT | DT_SINGLELINE);

		dc.SelectObject(pOldFont);

		BYTE* pText = (BYTE*)GetItemData(nIndex);
		BYTE bChar = *(pText++);

		BYTE bString[1024];
		int nStringPos = 0;

		// First, get all the DTE and names out,
		// converting it into an entire string of single characters.
		while(bChar)
		{
			if(bChar >= 0x80 && bChar <= 0xFF)
			{
				BYTE bDTE1 = g_rawDTE[(bChar - 0x80) * 2];
				BYTE bDTE2 = g_rawDTE[(bChar - 0x80) * 2 + 1];

				bString[nStringPos++] = bDTE1;
				bString[nStringPos++] = bDTE2;
			}
			if(bChar >= 0x02 && bChar <= 0x0F)
			{
				for(int i = 0; i < 6; i++)
				{
					if(g_rawNames[bChar - 0x02][i] != 0x00)
						bString[nStringPos++] = g_rawNames[bChar - 0x02][i];
				}
			}
			if(bChar >= 0x19 && bChar <= 0x1B)
			{
				for(int i = 0; i < 6; i++)
				{
					if(g_rawCtrl[bChar - 0x19][i] != 0x00)
						bString[nStringPos++] = g_rawCtrl[bChar - 0x19][i];
				}
			}
			else if(bChar == 0x11 || bChar == 0x16)
			{
				bString[nStringPos++] = bChar;

				while(bChar != 0x12)
				{
					bChar = *(pText++);
					bString[nStringPos++] = bChar;
				}
			}
			else if(bChar == 0x14)
			{
				bString[nStringPos++] = bChar;
				bString[nStringPos++] = *(pText++);
			}
			else
			{
				bString[nStringPos++] = bChar;
			}

			bChar = *(pText++);
		}

		bString[nStringPos++] = 0x00;

		nStringPos = 0;
		bChar = bString[nStringPos++];
		BYTE bWord[256];

		int xpos = 12, ypos = 8;
		int nWordWidth = 0;
		int nWordPos = 0;

		while(bChar != 0x00 && bChar != 0x13)
		{
			if(bChar == 0x01 || xpos > WINDOWWIDTH)
			{
				if(nWordWidth + xpos > WINDOWWIDTH)
				{
					xpos = 12;
					ypos += 15;
				}

				for(int i = 0; i < nWordPos; i++)
				{
					xpos += OutputVariableFontChar(&dc, CPoint(winRect.left + xpos, winRect.top + ypos),
						m_pDoc, bWord[i]);
				}

				nWordWidth = 0;
				nWordPos = 0;

				xpos = 12;
				ypos += 15;
			}
			else if(bChar >= 0x20 && bChar <= 0x73)
			{
				bWord[nWordPos++] = bChar;
				nWordWidth += m_pDoc->charWidths[bChar];
			}
			else if(bChar == 0x11 || bChar == 0x16)
			{
				while(bChar != 0x12)
					bChar = bString[nStringPos++];
			}
			else if(bChar == 0x14)
			{
				BYTE bChar = bString[nStringPos++];
				xpos += bChar * m_pDoc->charWidths[0x7F];
			}
			else if(bChar == 0x7F)
			{
				if(nWordWidth + xpos + m_pDoc->charWidths[bChar] > WINDOWWIDTH)
				{
					xpos = 12;
					ypos += 15;
				}

				for(int i = 0; i < nWordPos; i++)
				{
					xpos += OutputVariableFontChar(&dc, CPoint(winRect.left + xpos, winRect.top + ypos),
						m_pDoc, bWord[i]);
				}

				xpos += m_pDoc->charWidths[bChar];
				nWordWidth = 0;
				nWordPos = 0;
			}

			bChar = bString[nStringPos++];
		}

		if(nWordPos)
		{
			if(nWordWidth + xpos > WINDOWWIDTH)
			{
				xpos = 12;
				ypos += 15;
			}

			for(int i = 0; i < nWordPos; i++)
			{
				xpos += OutputVariableFontChar(&dc, CPoint(winRect.left + xpos, winRect.top + ypos),
					m_pDoc, bWord[i]);
			}
		}
	}

	dc.Detach();
}
