#if !defined(AFX_DIALOGUEVIEW_H__5C63EC4F_8DF6_11D3_BC29_00E029364BE2__INCLUDED_)
#define AFX_DIALOGUEVIEW_H__5C63EC4F_8DF6_11D3_BC29_00E029364BE2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DialogueView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CDialogueView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "cdxCSizingFormView.h"
#include "DialoguePageList.h"
#include "DialogueList.h"
#include "DialogueEdit.h"
#include "FindReplaceSheet.h"

class CDialogueView : public cdxCSizingFormView
{
protected:
	CDialogueView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CDialogueView)

	int m_nDirection;

// Form Data
public:
	//{{AFX_DATA(CDialogueView)
	enum { IDD = IDF_DIALOGUE };
	CButton	m_wndApply;
	CStatic	m_wndMinBounds;
	CDialogueEdit	m_wndEdit;
	CDialoguePageList	m_wndPages;
	CDialogueList	m_wndDialogueList;
	//}}AFX_DATA

// Attributes
public:
	CFF3Doc* GetDocument();

protected:
	CFont m_dlgFont;

// Operations
public:
	void OnProperties();
	CFindReplaceSheet* m_pFindReplace;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDialogueView)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CDialogueView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CDialogueView)
	afx_msg void OnSelChangeDialogueList();
	afx_msg void OnApply();
	afx_msg void OnUpdateEditClipboard(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditUndo(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditPaste(CCmdUI* pCmdUI);
	afx_msg void OnEditCut();
	afx_msg void OnEditCopy();
	afx_msg void OnEditPaste();
	afx_msg void OnEditUndo();
	afx_msg void OnEditGoto();
	//}}AFX_MSG
	afx_msg LRESULT OnDialogueSwitch(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnCompareView(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in LeftView.cpp
inline CFF3Doc* CDialogueView::GetDocument()
   { return (CFF3Doc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DIALOGUEVIEW_H__5C63EC4F_8DF6_11D3_BC29_00E029364BE2__INCLUDED_)
