// EditTriggerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FF3Edit.h"
#include "EditTriggerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditTriggerDlg dialog


CEditTriggerDlg::CEditTriggerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEditTriggerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEditTriggerDlg)
	m_nSourceX = 0;
	m_nSourceY = 0;
	m_nDestX = 0;
	m_nDestY = 0;
	m_nDestination = 0;
	m_nFacing = 0;
	m_nShowName = 0;
	//}}AFX_DATA_INIT
}


void CEditTriggerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditTriggerDlg)
	DDX_Text(pDX, IDC_TRIGGER_SRCX, m_nSourceX);
	DDV_MinMaxByte(pDX, m_nSourceX, 0, 255);
	DDX_Text(pDX, IDC_TRIGGER_SRCY, m_nSourceY);
	DDV_MinMaxByte(pDX, m_nSourceY, 0, 255);
	DDX_Text(pDX, IDC_TRIGGER_DESTX, m_nDestX);
	DDV_MinMaxByte(pDX, m_nDestX, 0, 255);
	DDX_Text(pDX, IDC_TRIGGER_DESTY, m_nDestY);
	DDV_MinMaxByte(pDX, m_nDestY, 0, 255);
	DDX_Text(pDX, IDC_TRIGGER_DEST, m_nDestination);
	DDX_CBIndex(pDX, IDC_TRIGGER_FACING, m_nFacing);
	DDX_Check(pDX, IDC_TRIGGER_SHOWNAME, m_nShowName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditTriggerDlg, CDialog)
	//{{AFX_MSG_MAP(CEditTriggerDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditTriggerDlg message handlers

BOOL CEditTriggerDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
