#if !defined(AFX_FF3LISTBOX_H__D7D380A1_A685_11D3_BC2A_00E029364BE2__INCLUDED_)
#define AFX_FF3LISTBOX_H__D7D380A1_A685_11D3_BC2A_00E029364BE2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// FF3ListBox.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CFF3ListBox window

class CFF3ListBox;

#define FF3LB_ITEMCHANGED		1000

#define FF3LBS_NOCHANGE			0x0001
#define FF3LBS_FFEMPTY			0x0002

class XFF3ListBoxPopup : public CListBox
{
protected:
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	DECLARE_MESSAGE_MAP()
};

class CFF3ListBoxPopup : public CMiniFrameWnd
{
protected:

public:
	void Invoke(CFF3ListBox* pParent, CFF3Doc* pDoc, CPoint pt, int nWidth, CPtrArray* aStrings, int nLength, int nSel);
	void CancelWindow(BOOL bSelected);
	void GetText(int nIndex, CString& rString);

	int m_nSel;
	int m_nItemToChange;

protected:
	int m_nModalResult;
	XFF3ListBoxPopup m_wndList;
	BOOL m_bValid;
	BOOL m_bCanceled;
	CPtrArray* m_pArray;
	int m_nLength;
	DWORD m_modal;
	BOOL m_bFFEmpty;

	CFF3ListBox* m_pParent;
	CFF3Doc* m_pDoc;

public:
	virtual BOOL Create(CWnd* pParentWnd);
	void AddItem(LPCTSTR lpszText, BOOL bState);
	void GetItemState(int nIndex);

protected:
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);

	afx_msg LONG OnSetFont(UINT hFont, LONG fRedraw);
	afx_msg void OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized);
	afx_msg void OnMeasureItem(int nID, LPMEASUREITEMSTRUCT lpmis);
	afx_msg void OnDrawItem(int nID, LPDRAWITEMSTRUCT lpdis);

	DECLARE_MESSAGE_MAP()
};

class CFF3ListBox : public CListBox
{
// Construction
public:
	CFF3ListBox();

// Attributes
public:
	CPtrArray* m_pArray;
	int m_nActiveButton;

	DWORD m_dwListStyle;

protected:
	CFF3ListBoxPopup* m_wndList;

public:
	CFF3Doc* m_pDoc;

// Operations
public:
	int AddItem(int nDataIndex, int nLength);
	int GetItem(int nIndex);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFF3ListBox)
	public:
	virtual void MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct);
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
	protected:
	virtual void PreSubclassWindow();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CFF3ListBox();

	// Generated message map functions
protected:
	//{{AFX_MSG(CFF3ListBox)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FF3LISTBOX_H__D7D380A1_A685_11D3_BC2A_00E029364BE2__INCLUDED_)
