#if !defined(AFX_LUMINANCESLIDER_H__07324829_CDCA_11D3_BC2A_00E029364BE2__INCLUDED_)
#define AFX_LUMINANCESLIDER_H__07324829_CDCA_11D3_BC2A_00E029364BE2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// LuminanceSlider.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CLuminanceSlider window

class CLuminanceSlider : public CWnd
{
// Construction
public:
	CLuminanceSlider();

// Attributes
public:
	double m_Sat, m_Hue, m_Lum;

protected:
	CDC dcSlider;
	CBitmap bmpSlider;
	CBitmap* oldSliderBmp;

	int m_nPos;

	BOOL m_bTracking;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CLuminanceSlider)
	protected:
	virtual void PreSubclassWindow();
	//}}AFX_VIRTUAL

// Implementation
public:
	void SetLuminance(double l);
	virtual ~CLuminanceSlider();

	// Generated message map functions
protected:
	//{{AFX_MSG(CLuminanceSlider)
	afx_msg void OnDestroy();
	afx_msg void OnPaint();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LUMINANCESLIDER_H__07324829_CDCA_11D3_BC2A_00E029364BE2__INCLUDED_)
