#if !defined(AFX_MAPTRIGGERDLG_H__041D5EC0_4398_11D3_BC29_A50279B4BE39__INCLUDED_)
#define AFX_MAPTRIGGERDLG_H__041D5EC0_4398_11D3_BC29_A50279B4BE39__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MapTriggerDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CMapTriggerDlg dialog

#include "cdxCSizingDialog.h"
#include "FF3Data.h"

#include "MenuButton.h"

class CMapTriggerDlg : public cdxCSizingDialog
{
// Construction
public:
	void AddTrigger(Trigger* pTrigger);
	CMapTriggerDlg(CWnd* pParent = NULL);   // standard constructor
	CView* m_pView;

	WorldData* m_worldData;

// Dialog Data
	//{{AFX_DATA(CMapTriggerDlg)
	enum { IDD = IDD_MAPTRIGGERDLG };
	CButton	m_wndDeleteAllTriggers;
	CButton	m_wndDeleteTrigger;
	CButton	m_wndEditTrigger;
	CMenuButton	m_wndAddTrigger;
	CButton	m_wndGotoDestination;
	CButton	m_wndGotoTrigger;
	CListCtrl	m_wndTriggerList;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMapTriggerDlg)
	public:
	virtual BOOL Create(CView* pView);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CMapTriggerDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnGotoTrigger();
	afx_msg void OnChangedTriggerList(NMHDR* pNotifyStruct, LRESULT* result);
	afx_msg void OnEditTriggerDblClk(NMHDR* pNotifyStruct, LRESULT* result);
	afx_msg void OnEditTrigger();
	afx_msg void OnClose();
	afx_msg void OnDestroy();
	afx_msg void OnAddEntranceTrigger();
	afx_msg void OnAddEventTrigger();
	afx_msg void OnDeleteTrigger();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAPTRIGGERDLG_H__041D5EC0_4398_11D3_BC29_A50279B4BE39__INCLUDED_)
