#if !defined(AFX_PALETTEEDITDLG_H__07324824_CDCA_11D3_BC2A_00E029364BE2__INCLUDED_)
#define AFX_PALETTEEDITDLG_H__07324824_CDCA_11D3_BC2A_00E029364BE2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PaletteEditDlg.h : header file
//

#include "ColorSelector.h"
#include "ColorWheel.h"
#include "LuminanceSlider.h"
#include "ColorBox.h"

/////////////////////////////////////////////////////////////////////////////
// CPaletteEditDlg dialog

class CPaletteEditDlg : public CDialog
{
// Construction
public:
	CPaletteEditDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CPaletteEditDlg)
	enum { IDD = IDD_PALETTE_EDITOR };
	CEdit	m_wndLum;
	CEdit	m_wndSat;
	CEdit	m_wndHue;
	CEdit	m_wndBlue;
	CEdit	m_wndGreen;
	CEdit	m_wndRed;
	CColorBox	m_wndOrigColorBox;
	CColorBox	m_wndColorBox;
	CColorWheel	m_wndWheel;
	CLuminanceSlider m_wndLumSlider;
	//}}AFX_DATA

	WORD m_wColor;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPaletteEditDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	BOOL m_bChangeProg;

	// Generated message map functions
	//{{AFX_MSG(CPaletteEditDlg)
	afx_msg void OnWheelChanged();
	afx_msg void OnLuminanceChanged();
	afx_msg void OnChangeRed();
	afx_msg void OnChangeGreen();
	afx_msg void OnChangeBlue();
	afx_msg void OnChangeHue();
	afx_msg void OnChangeLum();
	afx_msg void OnChangeSat();
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PALETTEEDITDLG_H__07324824_CDCA_11D3_BC2A_00E029364BE2__INCLUDED_)
