#if !defined(AFX_PIXELEDITOR_H__9D9A9ADA_C388_11D3_BC2A_00E029364BE2__INCLUDED_)
#define AFX_PIXELEDITOR_H__9D9A9ADA_C388_11D3_BC2A_00E029364BE2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PixelEditor.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CPixelEditor window

#define PED_IMAGECHANGED	1001

class CPixelEditor : public CWnd
{
// Construction
public:
	CPixelEditor();

// Attributes
public:

protected:
	BYTE* m_pixelArray;
	WORD* m_colorArray;

	CSize m_size;
	int m_nPixelSize;
	int m_nColors;

	BOOL m_bLeftDown;
	BOOL m_bRightDown;

	BYTE m_nFGColor;
	BYTE m_nBGColor;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPixelEditor)
	//}}AFX_VIRTUAL

// Implementation
public:
	void SetColor(int index, WORD wColor);
	void Fill(BYTE bColor);
	void ShiftUp();
	void ShiftDown();
	void ShiftLeft();
	void ShiftRight();

	void SetCurrentColors(int bFG, int bBG);
	BYTE GetPixel(int x, int y);
	void SetPixel(int x, int y, BYTE bColor);
	void SetColors(WORD* aColors, int nColors);
	void SetSizes(int x, int y, int pixelSize);
	virtual ~CPixelEditor();

	// Generated message map functions
protected:
	//{{AFX_MSG(CPixelEditor)
	afx_msg void OnPaint();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PIXELEDITOR_H__9D9A9ADA_C388_11D3_BC2A_00E029364BE2__INCLUDED_)
