// PropTreeInLineEdit.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CPropTreeInLineEdit window

#ifndef _PROPTREEINLINEEDIT_H_
#define _PROPTREEINLINEEDIT_H_

#include "FF3Doc.h"

#define PTEF_GROWHORIZ		0x00000001
#define PTEF_GROWVERT		0x00000002			// Applies only to multi-line controls

class CPropTreeInLineEdit : public CEdit
{
// Construction
public:
	CString m_strText;
	void SetFlags(DWORD flags);
	void DoModal();
	CPropTreeInLineEdit();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPropTreeInLineEdit)
	public:
	virtual BOOL Create(DWORD dwStyle, CWnd* pParentWnd, UINT nID);
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CPropTreeInLineEdit();

	// Generated message map functions
protected:
	DWORD m_dwFlags;
	int m_nModalResult;
	//{{AFX_MSG(CPropTreeInLineEdit)
	afx_msg void OnKillFocus();
	afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

class CPropTreeInLineFF3Edit : public CWnd
{
// Construction
public:
	CPropTreeInLineFF3Edit();

// Attributes
public:

// Operations
public:
	int m_nMaxLength;
	void DoModal();
	
	DWORD m_nModalResult;

protected:
	int m_nCaret;
	BOOL m_bTracking;
	BOOL m_bReturnDown;

public:
	CFF3Doc* m_pDoc;

	BYTE* m_pText;
	int m_nTextLength;
	BOOL m_bValid;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFF3EditCtrl)
	public:
	virtual BOOL Create(DWORD dwStyle, CWnd* pParentWnd, UINT nID);
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	//}}AFX_VIRTUAL

// Implementation
public:
	void SizeToContent();
	void SetText(BYTE* pText, int len);
	virtual ~CPropTreeInLineFF3Edit();

	// Generated message map functions
protected:
	//{{AFX_MSG(CFF3EditCtrl)
	afx_msg void OnPaint();
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif