#if !defined(AFX_SHOPEDITVIEW_H__D7D380A0_A685_11D3_BC2A_00E029364BE2__INCLUDED_)
#define AFX_SHOPEDITVIEW_H__D7D380A0_A685_11D3_BC2A_00E029364BE2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ShopEditView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CShopEditView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "FF3ComboBox.h"
#include "FF3ListBox.h"
#include "FF3EditCtrl.h"
#include "SizingFormView.h"
#include "PropertyTree.h"

class CShopEditView : public CSizingFormView
{
protected:
	CShopEditView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CShopEditView)

// Form Data
public:
	//{{AFX_DATA(CShopEditView)
	enum { IDD = IDF_SHOP };
	CSpinButtonCtrl	m_wndShopSpin;
	CPropertyTree m_wndTree;
	int		m_nShop;
	int		m_nTitle;
	//}}AFX_DATA

// Attributes
public:

protected:
	BOOL m_bValid;

	CPtrArray m_itemArray;
	void UpdateTree();

// Operations
public:
	CFF3Doc* GetDocument();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CShopEditView)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CShopEditView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CShopEditView)
	afx_msg void OnChangeShopNum();
	//}}AFX_MSG
	afx_msg void OnChangeProperties(NMHDR* pNMHDR, LRESULT* pResult);
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in EventView.cpp
inline CFF3Doc* CShopEditView::GetDocument()
   { return (CFF3Doc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SHOPEDITVIEW_H__D7D380A0_A685_11D3_BC2A_00E029364BE2__INCLUDED_)
