// TileListBox.h : header file
//

#ifndef __TILELISTBOX_H__
#define __TILELISTBOX_H__

#include "DirectDrawListBox.h"
#include "FF3Data.h"

/////////////////////////////////////////////////////////////////////////////
// CTileListBox window

class CTileListBox : public CDirectDrawListBox
{
// Construction
public:
	CTileListBox();

// Attributes
public:

protected:
	FF3Object* m_object;

// Operations
public:

protected:
	void Put16x16Tile(DDSURFACEDESC2* ddsd, int dx, int dy, BYTE bTile);
	void Put8x8ChunkyTile(DDSURFACEDESC2* ddsd, int dx, int dy, BYTE bTile);
//	void Put8x8x3Tile(DDSURFACEDESC2* ddsd, int dx, int dy, LocationTilePart* pTilePart);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTileListBox)
	public:
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
	virtual void MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CTileListBox();

	// Generated message map functions
protected:
	//{{AFX_MSG(CTileListBox)
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

#endif