//  ViewGroups.h : Declarations of view groups
//

#include "stdafx.h"
#include "ViewGroups.h"

/////////////////////////////////////////////////////////////////////

// WorldMapGroup: Used for World of Balance and World of Ruin.
BEGIN_VIEW_GROUP(WorldMapGroup)
	ADD_VIEW_CLASS(Map, CMapView)
END_VIEW_GROUP()

// DialogueGroup: Used for all the dialogue and fonts.
BEGIN_VIEW_GROUP(DialogueGroup)
	ADD_VIEW_CLASS(Standard Dialogue, CDialogueView)
	ADD_VIEW_CLASS(Dialogue Font, CVFontEditView)
	ADD_VIEW_CLASS(Menu Font, CFFontEditView)
END_VIEW_GROUP()

// ItemGroup: Used for items and shops.
BEGIN_VIEW_GROUP(ItemGroup)
	ADD_VIEW_CLASS(Items, CItemEditView)
	ADD_VIEW_CLASS(Shops, CShopEditView)
	ADD_VIEW_CLASS(Magic, CMagicEditView)
	ADD_VIEW_CLASS(Espers, CEsperEditView)
END_VIEW_GROUP()

// MonsterGroup
BEGIN_VIEW_GROUP(MonsterGroup)
	ADD_VIEW_CLASS(Monster Formations, CMonsterFormationView)
	ADD_VIEW_CLASS(Monster Statistics, CMonsterEditView)
END_VIEW_GROUP()

// CharacterGroup
BEGIN_VIEW_GROUP(CharacterGroup)
	ADD_VIEW_CLASS(Character Packages, CCharStatsView)
END_VIEW_GROUP()

/////////////////////////////////////////////////////////////////////
