#if !defined(AFX_CDXCSIZINGFORMVIEW_H__6517AE15_5D12_11D2_BE4C_000000000000__INCLUDED_)
#define AFX_CDXCSIZINGFORMVIEW_H__6517AE15_5D12_11D2_BE4C_000000000000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// cdxCSizingFormView.h : header file
//

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

//
// cdxCSizingFormView.h : header file
// -----------------------------------------------------------------------
// Author:  Hans Bhler (hans.buehler@student.hu-berlin.de)
//          codex design (http://www-pool.mathematik.hu-berlin.de/~codex
// Version: 1.1
// Release: 3 (Jan 1999 to www.codeguru.com)
// -----------------------------------------------------------------------
// Changes to V1.1:
// - Destructor no longer calls a virtual function.
// -----------------------------------------------------------------------
// Comments welcome.
//

#include	"cdxCDynamicControlsManager.h"

/*
 * cdxCSizingFormView[CFormView,cdxCDynamicControlsManager]
 * ========================================================
 * A CFormView with the capability to automatically reposition its controls.
 */

class cdxCSizingFormView : public CFormView, public cdxCDynamicControlsManager
{
	DECLARE_DYNCREATE(cdxCSizingFormView);

private:
	cdxCSizingFormView() : CFormView((LPCTSTR)NULL) { ASSERT(false); }	// for using DYNCREATE()
protected:
	cdxCSizingFormView(LPCTSTR lpszTemplate) : CFormView(lpszTemplate) {}
	cdxCSizingFormView(UINT nIDTemplate) : CFormView(nIDTemplate) {}
	virtual ~cdxCSizingFormView() { cdxCSizingFormView::DestroyWindow(); }

	//
	// MFC stuff
	//
protected:
	void OnInitialUpdate(CWnd & ctrlPlacedInTheLowerRightEdgeOfTheClientArea, Freedom fd = fdAll);
	void OnInitialUpdate(const CSize & szNormalClientArea, Freedom fd = fdAll);

	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL DestroyWindow(void) { cdxCDynamicControlsManager::DoDestroyWindow(); return CFormView::DestroyWindow(); }
	afx_msg void OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI);
	afx_msg void OnSize(UINT nType, int cx, int cy);

	DECLARE_MESSAGE_MAP()

	//
	// please call OnInitialUpdate(CWnd &, Freedom)
	// instead !
	//
private:
	virtual void OnInitialUpdate() { ASSERT(false); }
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CDXCSIZINGFORMVIEW_H__6517AE15_5D12_11D2_BE4C_000000000000__INCLUDED_)
