#if !defined(AFX_BATTLEPREVIEWWND_H__4C901E80_D13D_11D3_BC2A_00E029364BE2__INCLUDED_)
#define AFX_BATTLEPREVIEWWND_H__4C901E80_D13D_11D3_BC2A_00E029364BE2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// BattlePreviewWnd.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CBattlePreviewWnd window

#define BPN_POSITIONCHANGED		1

class CBattlePreviewWnd : public CWnd
{
// Construction
public:
	CBattlePreviewWnd();

// Attributes
public:
	BOOL visible[6];
	CPoint positions[6];
	CSize sizes[6];
	int active;

	CFF3Doc* m_pDoc;
	int monsters[6];

protected:
	CPoint anchor;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBattlePreviewWnd)
	//}}AFX_VIRTUAL

// Implementation
public:
	void DrawMonster(CDC* pDC, int nMonst);
	void GetItemRect(int nIndex, LPRECT lpRect);
	virtual ~CBattlePreviewWnd();

	// Generated message map functions
protected:
	void Put8x8x3Tile(CDC* pDC, int dx, int dy, MonsterVisuals* pVis, int offset);
	void Put8x8x4Tile(CDC* pDC, int dx, int dy, MonsterVisuals* pVis, int offset);
	//{{AFX_MSG(CBattlePreviewWnd)
	afx_msg void OnPaint();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BATTLEPREVIEWWND_H__4C901E80_D13D_11D3_BC2A_00E029364BE2__INCLUDED_)
