#if !defined(AFX_CHARSTATSVIEW_H__C69D10A0_E792_11D3_BC2A_00E029364BE2__INCLUDED_)
#define AFX_CHARSTATSVIEW_H__C69D10A0_E792_11D3_BC2A_00E029364BE2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CharStatsView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CCharStatsView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "SizingFormView.h"

#include "FF3ListBox.h"
#include "FF3EditCtrl.h"

class CCharStatsView : public CSizingFormView
{
protected:
	CCharStatsView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CCharStatsView)

// Form Data
public:
	//{{AFX_DATA(CCharStatsView)
	enum { IDD = IDF_CHARSTATS };
	CSpinButtonCtrl	m_wndCharSpin;
	CListCtrl	m_wndProgression;
	CFF3ListBox	m_wndEquipment;
	CFF3ListBox	m_wndCommands;
	CFF3EditCtrl	m_wndName;
	//}}AFX_DATA

	BOOL m_bValid;

	CPtrArray m_itemArray;
	CPtrArray m_cmdArray;

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCharStatsView)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CCharStatsView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	Character* GetCharacter(int nIndex);
	void UpdateControls(int nIndex);
	void UpdateProgression();

	// Generated message map functions
	//{{AFX_MSG(CCharStatsView)
	afx_msg void OnChangeCharnum();
	afx_msg void OnChangeInitialhp();
	afx_msg void OnChangeInitialmp();
	afx_msg void OnChangeVigor();
	afx_msg void OnChangeSpeed();
	afx_msg void OnChangeMagicpower();
	afx_msg void OnChangeBattlepower();
	afx_msg void OnChangeDefense();
	afx_msg void OnChangeStamina();
	afx_msg void OnChangeMagicdefense();
	afx_msg void OnChangeMagicblock();
	afx_msg void OnChangeEvade();
	afx_msg void OnChangeBattlecmds();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CHARSTATSVIEW_H__C69D10A0_E792_11D3_BC2A_00E029364BE2__INCLUDED_)
