// EntranceTriggerPage.cpp : implementation file
//

#include "stdafx.h"
#include "FF3Edit.h"
#include "EntranceTriggerPage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEntranceTriggerPage property page

IMPLEMENT_DYNCREATE(CEntranceTriggerPage, CPropertyPage)

CEntranceTriggerPage::CEntranceTriggerPage() : CPropertyPage(CEntranceTriggerPage::IDD)
{
	//{{AFX_DATA_INIT(CEntranceTriggerPage)
	m_nSourceX = 0;
	m_nSourceY = 0;
	m_nDestX = 0;
	m_nDestY = 0;
	m_nDestination = 0;
	m_nFacing = 0;
	m_nShowName = 0;
	//}}AFX_DATA_INIT
}

CEntranceTriggerPage::~CEntranceTriggerPage()
{
}

void CEntranceTriggerPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEntranceTriggerPage)
	DDX_Control(pDX, IDC_TRIGGER_DEST, m_wndDest);
	DDX_Text(pDX, IDC_TRIGGER_SRCX, m_nSourceX);
	DDV_MinMaxByte(pDX, m_nSourceX, 0, 255);
	DDX_Text(pDX, IDC_TRIGGER_SRCY, m_nSourceY);
	DDV_MinMaxByte(pDX, m_nSourceY, 0, 255);
	DDX_Text(pDX, IDC_TRIGGER_DESTX, m_nDestX);
	DDV_MinMaxByte(pDX, m_nDestX, 0, 255);
	DDX_Text(pDX, IDC_TRIGGER_DESTY, m_nDestY);
	DDV_MinMaxByte(pDX, m_nDestY, 0, 255);
	DDX_HexValue(pDX, IDC_TRIGGER_DEST, m_nDestination, 3);
	DDX_CBIndex(pDX, IDC_TRIGGER_FACING, m_nFacing);
	DDX_Check(pDX, IDC_TRIGGER_SHOWNAME, m_nShowName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEntranceTriggerPage, CPropertyPage)
	//{{AFX_MSG_MAP(CEntranceTriggerPage)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEntranceTriggerPage message handlers
