#if !defined(AFX_ESPEREDITVIEW_H__CB79A7C3_C256_11D3_BC2A_00E029364BE2__INCLUDED_)
#define AFX_ESPEREDITVIEW_H__CB79A7C3_C256_11D3_BC2A_00E029364BE2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// EsperEditView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CEsperEditView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "SizingFormView.h"
#include "PropertyTree.h"
#include "FF3ListBox.h"

class CEsperEditView : public CSizingFormView
{
protected:
	CEsperEditView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CEsperEditView)

// Form Data
public:
	//{{AFX_DATA(CEsperEditView)
	enum { IDD = IDF_LISTPROPS };
	CPropertyTree	m_wndProps;
	CFF3ListBox	m_wndList;
	//}}AFX_DATA

// Attributes
public:

protected:
	CPtrArray m_esperArray;
	CPtrArray m_magicArray;

	CMap<UINT, UINT, BOOL, BOOL> m_expanded;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEsperEditView)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
protected:
	void UpdateTree();
	virtual ~CEsperEditView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CEsperEditView)
	afx_msg void OnSelChangeItemList();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	afx_msg void OnChangeProperties(NMHDR* pNMHDR, LRESULT* pResult);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ESPEREDITVIEW_H__CB79A7C3_C256_11D3_BC2A_00E029364BE2__INCLUDED_)
