// FindReplaceSheet.h : header file
//
// This class defines custom modal property sheet 
// CFindReplaceSheet.
 
#ifndef __FINDREPLACESHEET_H__
#define __FINDREPLACESHEET_H__

#include "FindReplacePages.h"
#include "PropFontSheet.h"

/////////////////////////////////////////////////////////////////////////////
// CFindReplaceSheet

class CFindReplaceSheet : public CPropFontSheet
{
	DECLARE_DYNAMIC(CFindReplaceSheet)

// Construction
public:
	CFindReplaceSheet(CWnd* pWndParent = NULL);

// Attributes
public:
	CFindReplacePage1 m_Page1;
	CFindReplacePage2 m_Page2;
	CFindReplacePage3 m_Page3;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFindReplaceSheet)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CFindReplaceSheet();

// Generated message map functions
protected:
	//{{AFX_MSG(CFindReplaceSheet)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

#endif	// __FINDREPLACESHEET_H__
