#if !defined(AFX_ITEMEDITVIEW_H__A98A4E40_BDFF_11D3_BC2A_00E029364BE2__INCLUDED_)
#define AFX_ITEMEDITVIEW_H__A98A4E40_BDFF_11D3_BC2A_00E029364BE2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ItemEditView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CItemEditView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "SizingFormView.h"
#include "PropertyTree.h"
#include "FF3ListBox.h"

class CItemEditView : public CSizingFormView
{
protected:
	CItemEditView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CItemEditView)

// Form Data
public:
	//{{AFX_DATA(CItemEditView)
	enum { IDD = IDF_LISTPROPS };
	CFF3ListBox	m_wndList;
	CPropertyTree	m_wndProps;
	//}}AFX_DATA

// Attributes
public:

protected:
	CPtrArray m_itemArray;
	CPtrArray m_magicArray;

	CMap<UINT, UINT, BOOL, BOOL> m_expanded;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CItemEditView)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
protected:
	void UpdateTree();
	virtual ~CItemEditView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CItemEditView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSelChangeItemList();
	//}}AFX_MSG
	afx_msg LRESULT OnCompareView(WPARAM wParam, LPARAM lParam);
	afx_msg void OnChangeProperties(NMHDR* pNMHDR, LRESULT* pResult);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ITEMEDITVIEW_H__A98A4E40_BDFF_11D3_BC2A_00E029364BE2__INCLUDED_)
