// MapTileDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FF3Edit.h"
#include "MapTileDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMapTileDlg dialog


CMapTileDlg::CMapTileDlg(CWnd* pParent /*=NULL*/)
	: cdxCSizingDialog(CMapTileDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMapTileDlg)
	//}}AFX_DATA_INIT
}


void CMapTileDlg::DoDataExchange(CDataExchange* pDX)
{
	cdxCSizingDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMapTileDlg)
	DDX_Control(pDX, IDC_TILELIST, m_wndTileList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMapTileDlg, cdxCSizingDialog)
	//{{AFX_MSG_MAP(CMapTileDlg)
	ON_WM_CLOSE()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMapTileDlg message handlers

BOOL CMapTileDlg::OnInitDialog() 
{
	cdxCSizingDialog::OnInitDialog();
	
	AddSzControl(m_wndTileList, mdResize, mdResize);

	m_wndTileList.SetColumnWidth(22);
	m_wndTileList.SetItemHeight(0, 22);

	SetWindowPos(NULL, Settings.wsTileWnd.rect.left, Settings.wsTileWnd.rect.top,
		Settings.wsTileWnd.rect.right - Settings.wsTileWnd.rect.left,
		Settings.wsTileWnd.rect.bottom - Settings.wsTileWnd.rect.top,
		(Settings.wsTileWnd.bVisible ? SWP_SHOWWINDOW : SWP_HIDEWINDOW) | SWP_NOZORDER);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CMapTileDlg::OnClose() 
{
	ShowWindow(SW_HIDE);
}

BOOL CMapTileDlg::Create(CView* pView) 
{
	m_pView = pView;
	return CDialog::Create(IDD, pView->GetParentFrame());
}

void CMapTileDlg::OnDestroy() 
{
	GetWindowRect(&Settings.wsTileWnd.rect);

	cdxCSizingDialog::OnDestroy();
}
