#if !defined(AFX_MONSTEREDITVIEW_H__7DAE6D61_D0CE_11D3_BC2A_00E029364BE2__INCLUDED_)
#define AFX_MONSTEREDITVIEW_H__7DAE6D61_D0CE_11D3_BC2A_00E029364BE2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MonsterEditView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CMonsterEditView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "SizingFormView.h"
#include "MonsterEditSheet.h"
#include "FF3ListBox.h"

class CMonsterEditView : public CSizingFormView
{
protected:
	CMonsterEditView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CMonsterEditView)

// Form Data
public:
	//{{AFX_DATA(CMonsterEditView)
	enum { IDD = IDF_LISTSHEET };
	CFF3ListBox	m_wndList;
	//}}AFX_DATA

	CMonsterEditSheet* m_propSheet;
	CPtrArray m_monsterArray;
	CPtrArray m_itemArray;

	BOOL m_bValid;

// Attributes
public:

// Operations
public:
	void UpdateControls(int nIndex);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMonsterEditView)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CMonsterEditView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CMonsterEditView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnSelChangeList();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MONSTEREDITVIEW_H__7DAE6D61_D0CE_11D3_BC2A_00E029364BE2__INCLUDED_)
