// MonsterStatsPage.cpp : implementation file
//

#include "stdafx.h"
#include "FF3Edit.h"
#include "FF3Doc.h"
#include "MonsterStatsPage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMonsterStatsPage property page

IMPLEMENT_DYNCREATE(CMonsterStatsPage, CPropertyPage)

CMonsterStatsPage::CMonsterStatsPage() : CPropertyPage(CMonsterStatsPage::IDD)
{
	//{{AFX_DATA_INIT(CMonsterStatsPage)
	//}}AFX_DATA_INIT
}

CMonsterStatsPage::~CMonsterStatsPage()
{
}

void CMonsterStatsPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMonsterStatsPage)
	DDX_Control(pDX, IDC_ELEMENTS, m_wndElements);
	DDX_Control(pDX, IDC_CONDITIONS, m_wndConditions);
	DDX_Control(pDX, IDC_PICTURE, m_wndPicture);
	DDX_Control(pDX, IDC_NAME, m_wndName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMonsterStatsPage, CPropertyPage)
	//{{AFX_MSG_MAP(CMonsterStatsPage)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMonsterStatsPage message handlers

BOOL CMonsterStatsPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	CRect rect;  m_wndConditions.GetClientRect(&rect);
	m_wndConditions.SetExtendedStyle(LVS_EX_CHECKBOXES);
	m_wndConditions.InsertColumn(0, NULL, LVCFMT_LEFT, rect.Width() - 16);
	
	m_wndElements.GetClientRect(&rect);
	int nWidth = (rect.Width() - 128 - GetSystemMetrics(SM_CXVSCROLL)) / 3;

	m_wndElements.InsertColumn(0, _T("Element"), LVCFMT_LEFT, 128, 0);
	m_wndElements.InsertColumn(1, _T("Absorb"), LVCFMT_CENTER, nWidth, 1);
	m_wndElements.InsertColumn(2, _T("No. Eff."), LVCFMT_CENTER, nWidth, 2);
	m_wndElements.InsertColumn(3, _T("Weak"), LVCFMT_CENTER, nWidth, 3);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
