// TabbedViewCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "FF3Edit.h"
#include "TabbedViewCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTabbedViewCtrl

CTabbedViewCtrl::CTabbedViewCtrl()
{
}

CTabbedViewCtrl::~CTabbedViewCtrl()
{
}


BEGIN_MESSAGE_MAP(CTabbedViewCtrl, CTabCtrl)
	//{{AFX_MSG_MAP(CTabbedViewCtrl)
	ON_MESSAGE(WM_SIZEPARENT, OnSizeParent)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTabbedViewCtrl message handlers

LRESULT CTabbedViewCtrl::OnSizeParent(WPARAM, LPARAM lParam)
{
	AFX_SIZEPARENTPARAMS* lpLayout = (AFX_SIZEPARENTPARAMS*)lParam;
	DWORD dwStyle = GetStyle();

	if(dwStyle & WS_VISIBLE)
	{
		CRect rect;  rect.CopyRect(&lpLayout->rect);
		MoveWindow(rect.left, rect.top, rect.Width(), rect.Height());

		CRect tabRect = rect;  AdjustRect(FALSE, &tabRect);
		
		// Adjust the rectangle so it looks more even.
		DWORD dwStyle = GetStyle();
		if(dwStyle & TCS_VERTICAL)
		{
			if(dwStyle & TCS_RIGHT) tabRect.right -= 2;
			else tabRect.left += 2;
		}
		else
		{
			if(dwStyle & TCS_BOTTOM) tabRect.bottom -= 2;
			else tabRect.top += 2;
		}

		::CopyRect(&lpLayout->rect, &tabRect);
	}

	
	return 0;
}
