// TileFormationWnd.h : header file
//

#ifndef __TILEFORMATIONWND_H__
#define __TILEFORMATIONWND_H__

#include "FF3Data.h"

#define TFW_TILEPARTCHANGE		0x100

/////////////////////////////////////////////////////////////////////////////
// CTileFormationWnd window

class CTileFormationWnd : public CWnd
{
// Construction
public:
	void SetAllTiles(BYTE tl, BYTE tr, BYTE bl, BYTE br);
	CTileFormationWnd();

// Attributes
public:
	WorldData* m_worldData;
	void SetCurrentTile(BYTE bTile);

	BYTE m_bCurrentTile;
	BYTE m_bCurrentTilePart;

protected:
	void Put8x8ChunkyTile(CDC* pDC, int dx, int dy, BYTE bTile);

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTileFormationWnd)
	protected:
	virtual void PreSubclassWindow();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CTileFormationWnd();

	// Generated message map functions
protected:
	//{{AFX_MSG(CTileFormationWnd)
	afx_msg void OnPaint();
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

#endif
