//  ViewGroups.h : Declarations of view groups
//

#if !defined(AFX_VIEWGROUPS_H_INCLUDED_)
#define AFX_VIEWGROUPS_H_INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "TabbedFrame.h"

#include "MapView.h"
#include "ItemEditView.h"
#include "ShopEditView.h"
#include "DialogueView.h"
#include "EsperEditView.h"
#include "MagicEditView.h"
#include "FontEditView.h"
#include "MonsterEditView.h"
#include "MonsterFormationView.h"
#include "CharStatsView.h"

/////////////////////////////////////////////////////////////////////

DECLARE_VIEW_GROUP(WorldMapGroup)
DECLARE_VIEW_GROUP(DialogueGroup)
DECLARE_VIEW_GROUP(ItemGroup)
DECLARE_VIEW_GROUP(MonsterGroup)
DECLARE_VIEW_GROUP(CharacterGroup)

/////////////////////////////////////////////////////////////////////

#endif // !defined(AFX_VIEWGROUPS_H_INCLUDED_)
