// TileEditWnd.h : header file
//

#ifndef __TILEEDITWND_H__
#define __TILEEDITWND_H__

#include "FF3Data.h"

#define TEW_TILEEDIT		0x100

/////////////////////////////////////////////////////////////////////////////
// CTileEditWnd window

class CTileEditWnd : public CButton
{
// Construction
public:
	void SetEditColor(BYTE bColor);
	CTileEditWnd();

// Attributes
public:
	WorldData* m_worldData;
	void SetCurrentTile(BYTE bTile);

	BYTE m_bCurrentTile;
	BYTE m_bColor;

protected:
	CRect m_rectOffset;

	void Put8x8ChunkyTile(DDSURFACEDESC2* ddsd, int dx, int dy, BYTE bTile);

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTileEditWnd)
	public:
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
	protected:
	virtual void PreSubclassWindow();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CTileEditWnd();

	// Generated message map functions
protected:
	//{{AFX_MSG(CTileEditWnd)
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnPaint();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

#endif
